package ca.openroad.thoughtfarmer.teamcity;

import com.intellij.openapi.diagnostic.Logger;
import jetbrains.buildServer.Build;
import jetbrains.buildServer.BuildAgent;
import jetbrains.buildServer.BuildType;
import jetbrains.buildServer.messages.Status;
import jetbrains.buildServer.messages.BuildMessage1;
import jetbrains.buildServer.notification.Notificator;
import jetbrains.buildServer.notification.NotificatorRegistry;
import jetbrains.buildServer.serverSide.*;
import jetbrains.buildServer.users.NotificatorPropertyKey;
import jetbrains.buildServer.users.PropertyKey;
import jetbrains.buildServer.users.SUser;
import jetbrains.buildServer.users.User;
import jetbrains.buildServer.vcs.VcsRoot;
import jetbrains.buildServer.vcs.VcsModification;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import x10.CM17ASerialController;
import x10.Command;

import java.util.*;
import java.io.IOException;

public class TeamCityX10Listener extends BuildServerAdapter {

    private static final Logger log = Logger.getInstance(TeamCityX10Listener.class.getName());

    private CM17ASerialController controller;
    private final SBuildServer myBuildServer;

    public TeamCityX10Listener(SBuildServer sBuildServer) {

        this.myBuildServer = sBuildServer;
    }

    public void register(){
        System.out.println("Registering TeamCityX10Listener");
        myBuildServer.addListener(this);
        try {
            controller = new CM17ASerialController("COM1");
        } catch (IOException e) {
            System.out.println(e);
        }
    }


/*
    public TeamCityX10Listener() {
        this.myBuildServer = null;
        try {
            controller = new CM17ASerialController("COM1");
        } catch (IOException e) {
            System.out.println(e);
        }
    }

*/
    private void sendCommand(byte command) {
        try {
            System.out.println("Sending command:" + command);
            controller.addCommand(new Command("A1", command));
        } catch (Exception ignored) {
            System.out.println(ignored);
        }
    }

/*

    public static void main(String[] args) {
        TeamCityX10Listener listener = new TeamCityX10Listener();
        listener.sendCommand(Command.ON);
        listener.sendCommand(Command.OFF);
        listener.sendCommand(Command.ON);
        listener.sendCommand(Command.OFF);
    }
*/
    public void agentRegistered(SBuildAgent sBuildAgent, long l) {
       //To change body of implemented methods use File | Settings | File Templates.
    }

    public void beforeAgentUnregistered(SBuildAgent sBuildAgent) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void agentUnregistered(SBuildAgent sBuildAgent) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void agentStatusChanged(@NotNull SBuildAgent sBuildAgent, boolean b, boolean b1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void agentRemoved(SBuildAgent sBuildAgent) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeAddedToQueue(SBuildType sBuildType) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeAddedToQueue(@NotNull SQueuedBuild sQueuedBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeRemovedFromQueue(SBuildType sBuildType, User user, String s, String s1, Date date) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildRemovedFromQueue(@NotNull SQueuedBuild sQueuedBuild, User user, String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildPinned(@NotNull SBuild sBuild, @Nullable User user, @Nullable String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildUnpinned(@NotNull SBuild sBuild, @Nullable User user, @Nullable String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildQueueOrderChanged() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeRegistered(SBuildType sBuildType) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeUnregistered(SBuildType sBuildType) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void beforeBuildTypeDeleted(@NotNull String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeDeleted(@NotNull String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTypeActiveStatusChanged(SBuildType sBuildType) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildStarted(SRunningBuild sRunningBuild) {
        System.out.println("Sending buildStarted message");
        sendCommand(Command.ON);
        sendCommand(Command.OFF);
        sendCommand(Command.ON);
        sendCommand(Command.OFF);
    }

    public void changesLoaded(SRunningBuild sRunningBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildChangedStatus(SRunningBuild sRunningBuild, Status status, Status status1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void beforeBuildFinish(SRunningBuild sRunningBuild, boolean b) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void beforeBuildFinish(SRunningBuild sRunningBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildFinished(SRunningBuild sRunningBuild) {
        System.out.println("Sending buildFinished message:" + sRunningBuild.getBuildStatus().getText());
        Status buildStatus = sRunningBuild.getBuildStatus();
        if(buildStatus.isSuccessful()) {
            sendCommand(Command.OFF);
        } else if(buildStatus.isFailed()) {
            sendCommand(Command.ON);
        }
    }

    public void buildInterrupted(SRunningBuild sRunningBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void messageReceived(SRunningBuild sRunningBuild, BuildMessage1 buildMessage1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void responsibleChanged(@NotNull SBuildType sBuildType, @NotNull ResponsibilityInfo responsibilityInfo, @NotNull ResponsibilityInfo responsibilityInfo1, boolean b) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void beforeEntryDelete(SFinishedBuild sFinishedBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void entryDeleted(SFinishedBuild sFinishedBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void projectCreated(String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void projectRemoved(String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void projectPersisted(String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void projectRestored(String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void serverShutdown() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void serverStartup() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void changeAdded(VcsModification vcsModification, VcsRoot vcsRoot, SRunningBuild sRunningBuild) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void changeAdded(@NotNull VcsModification vcsModification, @NotNull VcsRoot vcsRoot, @Nullable Collection<SBuildType> sBuildTypes) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void cleanupStarted() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void cleanupFinished() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void serverShutdownComplete() {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void sourcesVersionReleased(@NotNull BuildAgent buildAgent) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void sourcesVersionReleased(@NotNull BuildType buildType) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void sourcesVersionReleased(@NotNull BuildType buildType, @NotNull BuildAgent buildAgent) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void labelingFailed(SBuild sBuild, VcsRoot vcsRoot, Throwable throwable) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void labelingSucceed(SBuild sBuild, BuildRevision buildRevision) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildTagsChanged(SBuild sBuild, List<String> strings, List<String> strings1) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void buildCommented(@NotNull SBuild sBuild, @Nullable User user, @Nullable String s) {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
